% drop.pl
% May 18, 1996
% John Eikenberry
% Dec 13, 2035
% Douglas Miles
%
/* * module * 
% This file defines the basic drop predicate
% 
*/
% :-swi_module(user). 
:-swi_module(modDrop, []).

:- include(prologmud(mud_header)).

% :- register_module_type (mtCommand).

% orderedBy(tDropAble,tNearestReachableItem).



%=autodoc
%% action_info( ?Say, ?Invokes) is semidet.
%
% Action Info.
%
baseKB:action_info(actDrop(isOneOf([tDropAble,tNearestReachableItem,tObj,ftID])),"Drop an item").



%=autodoc
%% agent_call_command( ?Agent, ?ACT) is semidet.
%
% Agent Call Command.
%
baseKB:agent_call_command(Agent,actDrop(Obj)):- once(actDrop(Agent,Obj)).

% Drop something
actDrop(Agent,Obj) :-
	mudPossess(Agent,Obj),
        mudAtLoc(Agent,LOC),
        clr(mudPossess(Agent,Obj)),
        must(\+((mudPossess(Agent,Obj)))),
        ain(mudAtLoc(Obj,LOC)),
	must(call_update_charge(Agent,actDrop)),!.

%=autodoc
%% actDrop( ?Agent, ?Obj) is semidet.
%
% Single Doer Action Drop.
%


%Nothing to drop
actDrop(Agent,_) :-
	call_update_charge(Agent,actDrop),
	(add_cmdfailure(Agent,actDrop)).

% Record keeping
update_charge(Agent,actDrop) :- ain(mudEnergy(Agent, + -1)).

%=autodoc
%% update_charge( ?A, ?B) is semidet.
%
% Update Charge.
%




%=autodoc
%% agent_text_command( ?ARG1, ?Say, ?Agent, ?CMD) is semidet.
%
% Agent Text Command.
%
baseKB:agent_text_command(Agent,["drop",X],Agent,actDrop(parseForFn(tDroppable,X))).

%:-must_det(show_call(get_agent_text_command(agent1,[drop,item1],_R,_CMD))).

:- include(prologmud(mud_footer)).
